import os
import pandas as pd
from backtestingFinal import Backtest

# Load stock data from CSV files
stock_directory = "stockDataIndiSmall"
stock_data = {}
for file in os.listdir(stock_directory):
    if file.endswith(".csv"):
        file_path = os.path.join(stock_directory, file)
        stock_name = file.split("_")[0]
        stock_data[stock_name] = pd.read_csv(file_path)
        stock_data[stock_name]['timestamp'] = pd.to_datetime(stock_data[stock_name]['timestamp'])

# Run the backtest
backtest = Backtest(stock_data)
backtest.run()

# Plot the backtest results and print trade statistics
backtest.plot_results()