import tkinter as tk
from tkinter import ttk
from threading import Thread
import trading_algorithm  
from trading_algorithm import Algorithm

class TradingClient(ttk.Frame):
    def __init__(self, master=None, **kw):
        super().__init__(master, **kw)
        self.master = master
        self.master.title("Trading Client")
        self.pack(fill="both", expand=True)

        self.algorithm = Algorithm(alpha_vantage_api_key='JACJKLH87O6AUMBM')

        
        self.create_widgets()

    def create_widgets(self):
        top_frame = ttk.Frame(self)
        top_frame.pack(side="top", fill="x")

        self.strategy_var = tk.StringVar()
        self.strategy_var.set("Higher Highs")
        ttk.Label(top_frame, text="Strategy:").pack(side="left")
        self.strategy_menu = ttk.OptionMenu(top_frame, self.strategy_var, "Higher Highs", "Higher Highs", command=self.algorithm.set_strategy)
        self.strategy_menu.pack(side="left")

        ttk.Label(top_frame, text="Add Stock:").pack(side="left")
        self.stock_entry = ttk.Entry(top_frame)
        self.stock_entry.pack(side="left")

        self.add_stock_button = ttk.Button(top_frame, text="Add", command=self.add_stock)
        self.add_stock_button.pack(side="left")

        self.stock_list = ttk.Treeview(self, columns=("Stocks"), show="headings")
        self.stock_list.heading("Stocks", text="Stocks")
        self.stock_list.pack(fill="both", expand=True)

        bottom_frame = ttk.Frame(self)
        bottom_frame.pack(side="bottom", fill="x")

        self.start_button = ttk.Button(bottom_frame, text="Start Trading", command=self.start_trading)
        self.start_button.pack(side="left")

        self.pause_button = ttk.Button(bottom_frame, text="Pause Trading", command=self.pause_trading, state="disabled")
        self.pause_button.pack(side="left")

        self.resume_button = ttk.Button(bottom_frame, text="Resume Trading", command=self.resume_trading, state="disabled")
        self.resume_button.pack(side="left")

        self.stop_button = ttk.Button(bottom_frame, text="Stop Trading", command=self.stop_trading, state="disabled")
        self.stop_button.pack(side="left")

    def add_stock(self):
        stock = self.stock_entry.get()
        self.stock_entry.delete(0, "end")
        self.algorithm.add_stock(stock)
        self.stock_list.insert("", "end", values=(stock,))

    def start_trading(self):
        self.algorithm.start()
        self.start_button.config(state="disabled")
        self.pause_button.config(state="normal")
        self.stop_button.config(state="normal")

    def pause_trading(self):
        self.algorithm.pause()
        self.pause_button.config(state="disabled")
        self.resume_button.config(state="normal")

    def resume_trading(self):
        self.algorithm.resume()
        self.resume_button.config(state="disabled")
        self.pause_button.config(state="normal")

    def stop_trading(self):
        self.algorithm.stop()
        self.start_button.config(state="normal")
        self.pause_button.config(state="disabled")
        self.resume_button.config(state="disabled")
        self.stop_button.config(state="disabled")